﻿using Syncfusion.Data;
using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfTestingSample.Model;

namespace WpfTestingSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.datagrid.CurrentCellActivated += datagrid_CurrentCellActivated;
        }

        void datagrid_CurrentCellActivated(object sender, Syncfusion.UI.Xaml.Grid.CurrentCellActivatedEventArgs args)
        {
            int rowIndex = args.CurrentRowColumnIndex.RowIndex;
            int columnIndex = this.datagrid.ResolveToGridVisibleColumnIndex(args.CurrentRowColumnIndex.ColumnIndex);
            // Get the mapping name
            var mappingName = this.datagrid.Columns[columnIndex].MappingName;
            // Get the resolved current record index
            var recordIndex = this.datagrid.ResolveToRecordIndex(rowIndex);
            if (args.ActivationTrigger == ActivationTrigger.Mouse)
            {
                if (this.datagrid.View.TopLevelGroup != null)
                {
                    // Get the current row record while grouping
                    var record = this.datagrid.View.TopLevelGroup.DisplayElements[recordIndex];
                    var data = (record as RecordEntry).Data as BusinessObjects;
                    var cellvalue = data.GetType().GetProperty(mappingName).GetValue(data).ToString();

                    ToolTip toolTip = new ToolTip();
                    toolTip.Content = cellvalue;
                    toolTip.StaysOpen = false;
                    toolTip.IsOpen = true;
                }
                else
                {
                    // Get the current row record 
                    var record1 = this.datagrid.View.Records.GetItemAt(recordIndex);
                    var cellvalue = record1.GetType().GetProperty(mappingName).GetValue(record1).ToString();
                    ToolTip toolTip = new ToolTip();

                    toolTip.Content = cellvalue;
                    toolTip.StaysOpen = false;
                    toolTip.IsOpen = true;
                }
            }
        }
    }
}
